diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-helper.cc ns-3.43/src/wifi/helper/wifi-helper.cc
--- ns-3.42/src/wifi/helper/wifi-helper.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-helper.cc	2024-10-09 16:41:10.112656800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2008 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -40,7 +29,8 @@
 #include "ns3/vht-configuration.h"
 #include "ns3/wifi-mac-queue.h"
 #include "ns3/wifi-mac-trailer.h"
-#include "ns3/wifi-net-device.h"
+
+#include <memory>
 
 namespace ns3
 {
@@ -144,7 +134,8 @@
 }
 
 WifiPhyHelper::WifiPhyHelper(uint8_t nLinks)
-    : m_pcapDlt(PcapHelper::DLT_IEEE802_11)
+    : m_pcapDlt{PcapHelper::DLT_IEEE802_11},
+      m_pcapType{PcapCaptureType::PCAP_PER_PHY}
 {
     NS_ABORT_IF(nLinks == 0);
     m_phys.resize(nLinks);
@@ -177,22 +168,74 @@
 void
 WifiPhyHelper::DisablePreambleDetectionModel()
 {
-    for (auto& preambleDetectionModel : m_preambleDetectionModel)
+    m_preambleDetectionModel.clear();
+    m_preambleDetectionModel.resize(m_phys.size());
+}
+
+Ptr<PcapFileWrapper>
+WifiPhyHelper::GetOrCreatePcapFile(const std::shared_ptr<PcapFilesInfo>& info, uint8_t phyId)
+{
+    uint8_t fileIdx;
+    switch (info->pcapType)
+    {
+    case WifiPhyHelper::PcapCaptureType::PCAP_PER_DEVICE:
+        fileIdx = 0;
+        break;
+    case WifiPhyHelper::PcapCaptureType::PCAP_PER_PHY:
+        fileIdx = phyId;
+        break;
+    case WifiPhyHelper::PcapCaptureType::PCAP_PER_LINK:
+        if (const auto linkId = info->device->GetMac()->GetLinkForPhy(phyId))
+        {
+            fileIdx = *linkId;
+            break;
+        }
+        return nullptr;
+    default:
+        NS_ABORT_MSG("Unexpected PCAP capture type");
+        return nullptr;
+    }
+
+    if (!info->files.contains(fileIdx))
     {
-        preambleDetectionModel.SetTypeId(TypeId());
+        // file does not exist yet, create it
+        auto tmp = info->commonFilename;
+
+        // find the last point in the filename
+        auto pos = info->commonFilename.find_last_of('.');
+        // if not found, set pos to filename size
+        pos = (pos == std::string::npos) ? info->commonFilename.size() : pos;
+
+        // insert PHY/link ID only for multi-link devices, unless a single PCAP is generated for the
+        // device
+        if ((info->device->GetNPhys() > 1) && (info->pcapType != PcapCaptureType::PCAP_PER_DEVICE))
+        {
+            tmp.insert(pos, "-" + std::to_string(fileIdx));
+        }
+
+        PcapHelper pcapHelper;
+        auto file = pcapHelper.CreateFile(tmp, std::ios::out, info->pcapDlt);
+        info->files.emplace(fileIdx, file);
     }
+
+    return info->files.at(fileIdx);
 }
 
 void
-WifiPhyHelper::PcapSniffTxEvent(Ptr<PcapFileWrapper> file,
+WifiPhyHelper::PcapSniffTxEvent(const std::shared_ptr<PcapFilesInfo>& info,
+                                uint8_t phyId,
                                 Ptr<const Packet> packet,
                                 uint16_t channelFreqMhz,
                                 WifiTxVector txVector,
                                 MpduInfo aMpdu,
                                 uint16_t staId)
 {
-    uint32_t dlt = file->GetDataLinkType();
-    switch (dlt)
+    auto file = GetOrCreatePcapFile(info, phyId);
+    if (!file)
+    {
+        return;
+    }
+    switch (info->pcapDlt)
     {
     case PcapHelper::DLT_IEEE802_11:
         file->Write(Simulator::Now(), packet);
@@ -210,12 +253,13 @@
         return;
     }
     default:
-        NS_ABORT_MSG("PcapSniffTxEvent(): Unexpected data link type " << dlt);
+        NS_ABORT_MSG("PcapSniffTxEvent(): Unexpected data link type " << info->pcapDlt);
     }
 }
 
 void
-WifiPhyHelper::PcapSniffRxEvent(Ptr<PcapFileWrapper> file,
+WifiPhyHelper::PcapSniffRxEvent(const std::shared_ptr<PcapFilesInfo>& info,
+                                uint8_t phyId,
                                 Ptr<const Packet> packet,
                                 uint16_t channelFreqMhz,
                                 WifiTxVector txVector,
@@ -223,8 +267,12 @@
                                 SignalNoiseDbm signalNoise,
                                 uint16_t staId)
 {
-    uint32_t dlt = file->GetDataLinkType();
-    switch (dlt)
+    auto file = GetOrCreatePcapFile(info, phyId);
+    if (!file)
+    {
+        return;
+    }
+    switch (info->pcapDlt)
     {
     case PcapHelper::DLT_IEEE802_11:
         file->Write(Simulator::Now(), packet);
@@ -242,7 +290,7 @@
         return;
     }
     default:
-        NS_ABORT_MSG("PcapSniffRxEvent(): Unexpected data link type " << dlt);
+        NS_ABORT_MSG("PcapSniffRxEvent(): Unexpected data link type " << info->pcapDlt);
     }
 }
 
@@ -281,7 +329,7 @@
         frameFlags |= RadiotapHeader::FRAME_FLAG_SHORT_PREAMBLE;
     }
 
-    if (txVector.GetGuardInterval() == 400)
+    if (txVector.GetGuardInterval().GetNanoSeconds() == 400)
     {
         frameFlags |= RadiotapHeader::FRAME_FLAG_SHORT_GUARD;
     }
@@ -339,7 +387,7 @@
         }
 
         mcsKnown |= RadiotapHeader::MCS_KNOWN_GUARD_INTERVAL;
-        if (txVector.GetGuardInterval() == 400)
+        if (txVector.GetGuardInterval().GetNanoSeconds() == 400)
         {
             mcsFlags |= RadiotapHeader::MCS_FLAGS_GUARD_INTERVAL;
         }
@@ -401,7 +449,7 @@
         }
 
         vhtKnown |= RadiotapHeader::VHT_KNOWN_GUARD_INTERVAL;
-        if (txVector.GetGuardInterval() == 400)
+        if (txVector.GetGuardInterval().GetNanoSeconds() == 400)
         {
             vhtFlags |= RadiotapHeader::VHT_FLAGS_GUARD_INTERVAL;
         }
@@ -517,11 +565,11 @@
         {
             data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_160MHZ;
         }
-        if (txVector.GetGuardInterval() == 1600)
+        if (txVector.GetGuardInterval().GetNanoSeconds() == 1600)
         {
             data5 |= RadiotapHeader::HE_DATA5_GI_1_6;
         }
-        else if (txVector.GetGuardInterval() == 3200)
+        else if (txVector.GetGuardInterval().GetNanoSeconds() == 3200)
         {
             data5 |= RadiotapHeader::HE_DATA5_GI_3_2;
         }
@@ -565,6 +613,18 @@
 }
 
 void
+WifiPhyHelper::SetPcapCaptureType(PcapCaptureType type)
+{
+    m_pcapType = type;
+}
+
+WifiPhyHelper::PcapCaptureType
+WifiPhyHelper::GetPcapCaptureType() const
+{
+    return m_pcapType;
+}
+
+void
 WifiPhyHelper::EnablePcapInternal(std::string prefix,
                                   Ptr<NetDevice> nd,
                                   bool promiscuous,
@@ -587,7 +647,6 @@
                     "WifiPhyHelper::EnablePcapInternal(): Phy layer in WifiNetDevice must be set");
 
     PcapHelper pcapHelper;
-
     std::string filename;
     if (explicitFilename)
     {
@@ -598,25 +657,15 @@
         filename = pcapHelper.GetFilenameFromDevice(prefix, device);
     }
 
-    uint8_t linkId = 0;
-    // find the last point in the filename
-    auto pos = filename.find_last_of('.');
-    // if not found, set pos to filename size
-    pos = (pos == std::string::npos) ? filename.size() : pos;
-
+    auto info = std::make_shared<PcapFilesInfo>(filename, m_pcapDlt, m_pcapType, device);
     for (auto& phy : device->GetPhys())
     {
-        std::string tmp = filename;
-        if (device->GetNPhys() > 1)
-        {
-            // insert LinkId only for multi-link devices
-            tmp.insert(pos, "-" + std::to_string(linkId++));
-        }
-        auto file = pcapHelper.CreateFile(tmp, std::ios::out, m_pcapDlt);
-        phy->TraceConnectWithoutContext("MonitorSnifferTx",
-                                        MakeBoundCallback(&WifiPhyHelper::PcapSniffTxEvent, file));
-        phy->TraceConnectWithoutContext("MonitorSnifferRx",
-                                        MakeBoundCallback(&WifiPhyHelper::PcapSniffRxEvent, file));
+        phy->TraceConnectWithoutContext(
+            "MonitorSnifferTx",
+            MakeBoundCallback(&WifiPhyHelper::PcapSniffTxEvent, info, phy->GetPhyId()));
+        phy->TraceConnectWithoutContext(
+            "MonitorSnifferRx",
+            MakeBoundCallback(&WifiPhyHelper::PcapSniffRxEvent, info, phy->GetPhyId()));
     }
 }
 
@@ -734,6 +783,45 @@
     m_ehtConfig.SetTypeId("ns3::EhtConfiguration");
 }
 
+namespace
+{
+/// Map strings to WifiStandard enum values
+const std::unordered_map<std::string, WifiStandard> WIFI_STANDARDS_NAME_MAP{
+    // clang-format off
+    {"802.11a",  WIFI_STANDARD_80211a},
+    {"11a",      WIFI_STANDARD_80211a},
+
+    {"802.11b",  WIFI_STANDARD_80211b},
+    {"11b",      WIFI_STANDARD_80211b},
+
+    {"802.11g",  WIFI_STANDARD_80211g},
+    {"11g",      WIFI_STANDARD_80211g},
+
+    {"802.11p",  WIFI_STANDARD_80211p},
+    {"11p",      WIFI_STANDARD_80211p},
+
+    {"802.11n",  WIFI_STANDARD_80211n},
+    {"11n",      WIFI_STANDARD_80211n},
+    {"HT",       WIFI_STANDARD_80211n},
+
+    {"802.11ac", WIFI_STANDARD_80211ac},
+    {"11ac",     WIFI_STANDARD_80211ac},
+    {"VHT",      WIFI_STANDARD_80211ac},
+
+    {"802.11ad", WIFI_STANDARD_80211ad},
+    {"11ad",     WIFI_STANDARD_80211ad},
+
+    {"802.11ax", WIFI_STANDARD_80211ax},
+    {"11ax",     WIFI_STANDARD_80211ax},
+    {"HE",       WIFI_STANDARD_80211ax},
+
+    {"802.11be", WIFI_STANDARD_80211be},
+    {"11be",     WIFI_STANDARD_80211be},
+    {"EHT",      WIFI_STANDARD_80211be},
+    // clang-format on
+};
+} // namespace
+
 void
 WifiHelper::SetStandard(WifiStandard standard)
 {
@@ -741,6 +829,14 @@
 }
 
 void
+WifiHelper::SetStandard(const std::string& standard)
+{
+    NS_ABORT_MSG_IF(!WIFI_STANDARDS_NAME_MAP.contains(standard),
+                    "Specified Wi-Fi standard " << standard << " is currently not supported");
+    SetStandard(WIFI_STANDARDS_NAME_MAP.at(standard));
+}
+
+void
 WifiHelper::DisableFlowControl()
 {
     m_enableFlowControl = false;
@@ -885,7 +981,10 @@
     LogComponentEnable("AarfWifiManager", logLevel);
     LogComponentEnable("AarfcdWifiManager", logLevel);
     LogComponentEnable("AdhocWifiMac", logLevel);
+    LogComponentEnable("AdvancedApEmlsrManager", logLevel);
+    LogComponentEnable("AdvancedEmlsrManager", logLevel);
     LogComponentEnable("AmrrWifiManager", logLevel);
+    LogComponentEnable("ApEmlsrManager", logLevel);
     LogComponentEnable("ApWifiMac", logLevel);
     LogComponentEnable("AparfWifiManager", logLevel);
     LogComponentEnable("ArfWifiManager", logLevel);
@@ -895,6 +994,7 @@
     LogComponentEnable("ChannelAccessManager", logLevel);
     LogComponentEnable("ConstantObssPdAlgorithm", logLevel);
     LogComponentEnable("ConstantRateWifiManager", logLevel);
+    LogComponentEnable("DefaultApEmlsrManager", logLevel);
     LogComponentEnable("DefaultEmlsrManager", logLevel);
     LogComponentEnable("DsssErrorRateModel", logLevel);
     LogComponentEnable("DsssPhy", logLevel);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-helper.h ns-3.43/src/wifi/helper/wifi-helper.h
--- ns-3.42/src/wifi/helper/wifi-helper.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-helper.h	2024-10-09 16:41:10.112656800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2008 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -26,15 +15,16 @@
 
 #include "ns3/qos-utils.h"
 #include "ns3/trace-helper.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
 
 #include <functional>
+#include <map>
 #include <vector>
 
 namespace ns3
 {
 
-class WifiNetDevice;
 class Node;
 class RadiotapHeader;
 class QueueItem;
@@ -180,6 +170,49 @@
     };
 
     /**
+     * An enumeration of the PCAP capture types.
+     * The PCAP capture type only matters for multi-link devices.
+     */
+    enum class PcapCaptureType
+    {
+        PCAP_PER_DEVICE, /**< Single capture file per device */
+        PCAP_PER_PHY,    /**< Single capture file per PHY */
+        PCAP_PER_LINK,   /**< Single capture file per link */
+    };
+
+    /**
+     * structure holding the information about PCAP files generated for a given device
+     */
+    struct PcapFilesInfo
+    {
+        /**
+         * Constructor
+         *
+         * \param filename the common file name of the PCAP files
+         * \param dlt the selected data link type of the pcap file
+         * \param type the selected PCAP capture type
+         * \param dev the WifiNetDevice for which the PCAP files are generated
+         */
+        PcapFilesInfo(const std::string& filename,
+                      PcapHelper::DataLinkType dlt,
+                      WifiPhyHelper::PcapCaptureType type,
+                      Ptr<WifiNetDevice> dev)
+            : commonFilename{filename},
+              pcapDlt{dlt},
+              pcapType{type},
+              device{dev},
+              files{}
+        {
+        }
+
+        std::string commonFilename;              ///< common file name of the PCAP files
+        PcapHelper::DataLinkType pcapDlt;        ///< the selected data link type of the pcap file
+        WifiPhyHelper::PcapCaptureType pcapType; ///< the selected PCAP capture type
+        Ptr<WifiNetDevice> device; ///< the WifiNetDevice for which the PCAP files are generated
+        std::map<uint8_t, Ptr<PcapFileWrapper>> files; ///< PCAP files indexed by PHY ID
+    };
+
+    /**
      * Set the data link type of PCAP traces to be used. This function has to be
      * called before EnablePcap(), so that the header of the pcap file can be
      * written correctly.
@@ -199,9 +232,28 @@
      */
     PcapHelper::DataLinkType GetPcapDataLinkType() const;
 
+    /**
+     * Set the PCAP capture type to be used. This function has to be called before EnablePcap().
+     *
+     * \see PcapCaptureType
+     *
+     * \param type The PCAP capture type
+     */
+    void SetPcapCaptureType(PcapCaptureType type);
+
+    /**
+     * Get the PCAP capture type to be used.
+     *
+     * \see PcapCaptureType
+     *
+     * \return The PCAP capture type to be used
+     */
+    PcapCaptureType GetPcapCaptureType() const;
+
   protected:
     /**
-     * \param file the pcap file wrapper
+     * \param info the information needed to write to the correct PCAP file
+     * \param phyId the ID of the PHY that raised the event
      * \param packet the packet
      * \param channelFreqMhz the channel frequency
      * \param txVector the TXVECTOR
@@ -210,14 +262,16 @@
      *
      * Handle TX pcap.
      */
-    static void PcapSniffTxEvent(Ptr<PcapFileWrapper> file,
+    static void PcapSniffTxEvent(const std::shared_ptr<PcapFilesInfo>& info,
+                                 uint8_t phyId,
                                  Ptr<const Packet> packet,
                                  uint16_t channelFreqMhz,
                                  WifiTxVector txVector,
                                  MpduInfo aMpdu,
                                  uint16_t staId = SU_STA_ID);
     /**
-     * \param file the pcap file wrapper
+     * \param info the information needed to write to the correct PCAP file
+     * \param phyId the ID of the PHY that raised the event
      * \param packet the packet
      * \param channelFreqMhz the channel frequency
      * \param txVector the TXVECTOR
@@ -227,7 +281,8 @@
      *
      * Handle RX pcap.
      */
-    static void PcapSniffRxEvent(Ptr<PcapFileWrapper> file,
+    static void PcapSniffRxEvent(const std::shared_ptr<PcapFilesInfo>& info,
+                                 uint8_t phyId,
                                  Ptr<const Packet> packet,
                                  uint16_t channelFreqMhz,
                                  WifiTxVector txVector,
@@ -243,6 +298,18 @@
 
   private:
     /**
+     * Get the PCAP file to write to from a list of PCAP files indexed by PHY ID.
+     * If PCAP files are generated per link, it might create a new file if a link
+     * has swapped to a new ID.
+     *
+     * \param info the information needed to write to the correct PCAP file
+     * \param phyId the ID of the PHY that raised the event
+     * \return the PCAP file to write to
+     */
+    static Ptr<PcapFileWrapper> GetOrCreatePcapFile(const std::shared_ptr<PcapFilesInfo>& info,
+                                                    uint8_t phyId);
+
+    /**
      * Get the Radiotap header for a transmitted packet.
      *
      * \param header the radiotap header to be filled in
@@ -311,6 +378,7 @@
                              bool explicitFilename) override;
 
     PcapHelper::DataLinkType m_pcapDlt; ///< PCAP data link type
+    PcapCaptureType m_pcapType;         ///< PCAP capture type
 };
 
 /**
@@ -331,7 +399,7 @@
      *
      * The default state is defined as being an Adhoc MAC layer with an ARF rate control algorithm
      * and both objects using their default attribute values.
-     * By default, configure MAC and PHY for 802.11a.
+     * By default, configure MAC and PHY for 802.11ax.
      */
     WifiHelper();
 
@@ -438,7 +506,7 @@
      * WifiMac::ConfigureStandard(standard) being called on each
      * installed MAC object.
      *
-     * The default standard of 802.11a will be applied if SetStandard()
+     * The default standard of 802.11ax will be applied if SetStandard()
      * is not called.
      *
      * Note that WifiMac::ConfigureStandard () will overwrite certain
@@ -456,6 +524,17 @@
     virtual void SetStandard(WifiStandard standard);
 
     /**
+     * \param standard String representation of the Wi-Fi standard
+     *
+     * This method overloads WifiHelper::SetStandard(WifiStandard standard) by allowing
+     * selected string names. For example, the strings "802.11ax", "11ax", and "HE"
+     * are equivalent and map to WIFI_STANDARD_80211ax. See the documentation of the specified
+     * function to see how it interacts with attribute configuration.
+     * \sa WifiHelper::SetStandard(WifiStandard standard)
+     */
+    void SetStandard(const std::string& standard);
+
+    /**
      * Helper function used to configure the HT options listed as attributes of
      * the HtConfiguration class.
      *
@@ -515,7 +594,7 @@
      * \param stream first stream index to use
      * \return the number of stream indices assigned by this helper
      */
-    int64_t AssignStreams(NetDeviceContainer c, int64_t stream);
+    static int64_t AssignStreams(NetDeviceContainer c, int64_t stream);
 
   protected:
     mutable std::vector<ObjectFactory> m_stationManager; ///< station manager
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-mac-helper.cc ns-3.43/src/wifi/helper/wifi-mac-helper.cc
--- ns-3.42/src/wifi/helper/wifi-mac-helper.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-mac-helper.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,24 +1,14 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
 
 #include "wifi-mac-helper.h"
 
+#include "ns3/ap-emlsr-manager.h"
 #include "ns3/boolean.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/emlsr-manager.h"
@@ -59,6 +49,7 @@
     m_protectionManager.SetTypeId("ns3::WifiDefaultProtectionManager");
     m_ackManager.SetTypeId("ns3::WifiDefaultAckManager");
     m_emlsrManager.SetTypeId("ns3::DefaultEmlsrManager");
+    m_apEmlsrManager.SetTypeId("ns3::DefaultApEmlsrManager");
 }
 
 WifiMacHelper::~WifiMacHelper()
@@ -167,6 +158,16 @@
         staMac->SetEmlsrManager(emlsrManager);
     }
 
+    // create and install the AP EMLSR Manager if this is an EHT AP MLD with EMLSR activated
+    if (BooleanValue emlsrActivated;
+        standard >= WIFI_STANDARD_80211be && apMac && apMac->GetNLinks() > 1 &&
+        device->GetEhtConfiguration()->GetAttributeFailSafe("EmlsrActivated", emlsrActivated) &&
+        emlsrActivated.Get())
+    {
+        auto apEmlsrManager = m_apEmlsrManager.Create<ApEmlsrManager>();
+        apMac->SetApEmlsrManager(apEmlsrManager);
+    }
+
     return mac;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-mac-helper.h ns-3.43/src/wifi/helper/wifi-mac-helper.h
--- ns-3.42/src/wifi/helper/wifi-mac-helper.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-mac-helper.h	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -170,6 +159,16 @@
     void SetEmlsrManager(std::string type, Args&&... args);
 
     /**
+     * Helper function used to set the AP EMLSR Manager that can be installed on an EHT AP MLD.
+     *
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param type the type of AP EMLSR Manager
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetApEmlsrManager(std::string type, Args&&... args);
+
+    /**
      * \param device the device within which the MAC object will reside
      * \param standard the standard to configure during installation
      * \returns a new MAC object.
@@ -190,6 +189,7 @@
     ObjectFactory m_ackManager;           ///< Factory to create an acknowledgment manager
     ObjectFactory m_muScheduler;          ///< Multi-user Scheduler object factory
     ObjectFactory m_emlsrManager;         ///< EMLSR Manager object factory
+    ObjectFactory m_apEmlsrManager;       ///< AP EMLSR Manager object factory
 };
 
 } // namespace ns3
@@ -287,6 +287,14 @@
     m_emlsrManager.Set(args...);
 }
 
+template <typename... Args>
+void
+WifiMacHelper::SetApEmlsrManager(std::string type, Args&&... args)
+{
+    m_apEmlsrManager.SetTypeId(type);
+    m_apEmlsrManager.Set(args...);
+}
+
 } // namespace ns3
 
 #endif /* WIFI_MAC_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-phy-rx-trace-helper.cc ns-3.43/src/wifi/helper/wifi-phy-rx-trace-helper.cc
--- ns-3.42/src/wifi/helper/wifi-phy-rx-trace-helper.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-phy-rx-trace-helper.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "wifi-phy-rx-trace-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-phy-rx-trace-helper.h ns-3.43/src/wifi/helper/wifi-phy-rx-trace-helper.h
--- ns-3.42/src/wifi/helper/wifi-phy-rx-trace-helper.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-phy-rx-trace-helper.h	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #ifndef WIFI_PHY_RX_TRACE_HELPER_H
@@ -671,7 +660,7 @@
      * boolean flag can be toggled to control the granularity and scope of data collection, enabling
      * customization of the analysis to focus on specific times of interest.
      */
-    bool m_statisticsCollectionPeriodStarted;
+    bool m_statisticsCollectionPeriodStarted{false};
 
     /**
      * Update the passed-in statistics object with statistics from the passed-in record.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-radio-energy-model-helper.cc ns-3.43/src/wifi/helper/wifi-radio-energy-model-helper.cc
--- ns-3.42/src/wifi/helper/wifi-radio-energy-model-helper.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-radio-energy-model-helper.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Network Security Lab, University of Washington, Seattle.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sidharth Nabar <snabar@uw.edu>, He Wu <mdzz@u.washington.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/wifi-radio-energy-model-helper.h ns-3.43/src/wifi/helper/wifi-radio-energy-model-helper.h
--- ns-3.42/src/wifi/helper/wifi-radio-energy-model-helper.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/wifi-radio-energy-model-helper.h	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Network Security Lab, University of Washington, Seattle.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sidharth Nabar <snabar@uw.edu>, He Wu <mdzz@u.washington.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/yans-wifi-helper.cc ns-3.43/src/wifi/helper/yans-wifi-helper.cc
--- ns-3.42/src/wifi/helper/yans-wifi-helper.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/yans-wifi-helper.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
